/////////////////////////////////////////////////////////////////////////////
//
// Last update	$Date: 2007/11/11 13:13:45 $ UTC
//   Revision   $Revision: 1.38 $
//
//	Modified by Claybird <claybird.without.wing@gmail.com>
//
// MenuExtension.cpp :	gVF ReNXgj[R|[lgNX̒`
//						LhaForgegj[
//
//	Original File Information:
// MenuExtension.cpp :	gVF ReNXgj[R|[lgNX̒`
//						l(TF)gj[
//
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "MenuData.h"
#include "MenuExtension.h"
#include "Main.h"
#include "resource.h"
#include "lfutil.h"

/*-------------------------------------------------------------------------*/
// CMenuExtension	RXgN^EfXgN^
/*-------------------------------------------------------------------------*/

// CMenuExtension
CMenuExtension::CMenuExtension(bool bRightDrag)
	:	m_cRef(0L),
		m_DataObjP(NULL),
		m_nCompressMenuCount(0),
		m_bRightDrag(bRightDrag),
		m_bForceExtraMenu(GetKeyState(VK_SHIFT)<0),	//SHIFTĂƂgj[[h
		m_nUserMenuCount(0)
{
	InterlockedIncrement(&g_cDllRef);
	dprintf(_T("\n\nCMenuExtension::CMenuExtension\n"));

	HRESULT hRes = ::CoInitialize(NULL);
	ATLASSERT(SUCCEEDED(hRes));
	_Module.Init(NULL,g_hInstDLL);

	// j[̏
	PrepareMenu();

	// OSo[WmF
	OSVERSIONINFO osv={sizeof(osv)};
	GetVersionEx(&osv);
	m_bXP=(osv.dwPlatformId==VER_PLATFORM_WIN32_NT)&&(osv.dwMajorVersion>5||(osv.dwMajorVersion==5&&osv.dwMinorVersion>=1));
}

// ~CMenuExtension
CMenuExtension::~CMenuExtension()
{
	dprintf(_T("CMenuExtension::~CMenuExtension\n\n\n"));

	//j[f[^̔j
	DeleteMenuData();

	// It@Ce[uGA̔j
	DeleteFileData();

	// f[^IuWFNg[X
	if(m_DataObjP){
		m_DataObjP->Release();
	}

	InterlockedDecrement(&g_cDllRef);
	_Module.Term();
	::CoUninitialize();
}

/*-------------------------------------------------------------------------*/
// CMenuExtension	
//
//			IUnknown C^[tFCX̃\bhQ
//
//				QueryInterface
//				AddRef
//				Release
//
/*-------------------------------------------------------------------------*/

// QueryInterface
STDMETHODIMP CMenuExtension::QueryInterface(
	REFIID		riid,
	LPVOID *	ppv)
{
	dprintf(_T("CMenuExtension::QueryInterface(ppvObj=%x , riid=%d)\n"),ppv,riid);

	*ppv = NULL;
	if(IsEqualIID(riid, IID_IShellExtInit) || IsEqualIID(riid, IID_IUnknown)){
		*ppv = (LPSHELLEXTINIT)this;
	}
	else if(IsEqualIID(riid, IID_IContextMenu)){
		*ppv = (LPCONTEXTMENU)this;
	}

    if(*ppv){
		static_cast<IUnknown*>(*ppv)->AddRef();
		return NOERROR;
	}

	return E_NOINTERFACE;
}

// AddRef
STDMETHODIMP_(ULONG) CMenuExtension::AddRef()
{
	dprintf(_T("CMenuExtension::AddRef (m_cRef=%d)\n"),m_cRef);

	InterlockedIncrement(&m_cRef);
	return m_cRef;
}

// Release
STDMETHODIMP_(ULONG) CMenuExtension::Release()
{
	dprintf(_T("CMenuExtension::Release (m_cRef=%d)\n"),m_cRef);

	ULONG theRef = InterlockedDecrement(&m_cRef);
	if(theRef == 0L)delete this;
	return theRef;	// [JϐgĂ̂ delete łlԂ悤
}

/*-------------------------------------------------------------------------*/
// CMenuExtension	
//
//			IShellExtInit C^[tFCX̃\bh
//
//				Initialize
//
/*-------------------------------------------------------------------------*/

// Initialize
STDMETHODIMP CMenuExtension::Initialize(
	LPCITEMIDLIST	pIDFolder,
	LPDATAOBJECT	pDataObj,
	HKEY			hRegKey)
{
	dprintf(_T("CMenuExtension::Initialize\n"));

	UNREFERENCED_PARAMETER(hRegKey);

	//ΏۃtH_擾
	if(m_bRightDrag){
		TCHAR Buffer[_MAX_PATH+3]={0};
		::SHGetPathFromIDList( pIDFolder, Buffer);
		PathQuoteSpaces(Buffer);
		m_strTargetFolder=Buffer;
	}

	if(m_DataObjP){
		m_DataObjP->Release();
		m_DataObjP = 0;
	}
    if(pDataObj){
    	m_DataObjP = pDataObj;
    	pDataObj->AddRef();
    }
    return NOERROR;
}

/*-------------------------------------------------------------------------*/
// CMenuExtension	
//
//			IShellExtInit C^[tFCX̃\bhQ
//
//				QueryContextMenu
//				InvokeCommand
//				GetCommandString
//
/*-------------------------------------------------------------------------*/

// QueryContextMenu
STDMETHODIMP CMenuExtension::QueryContextMenu(
	HMENU	hMenu,
	UINT	indexMenu,
	UINT	idCmdFirst,
	UINT	idCmdLast,
	UINT	uFlags)
{
	dprintf(_T("CMenuExtension::QueryContextMenu\n"));

	ASSERT(IsMenu(hMenu));

	// ǉ̃R}hp^ꍇ͉Ȃ
	if(m_CmdParamArray.empty()){
		dprintf(_T("\tCommand none"));
		return MAKE_HRESULT(SEVERITY_SUCCESS,FACILITY_NULL,0);
	}

	// uFlags  CMF_DEFAULTONLY ܂܂ꍇ͉Ȃ
	if (uFlags & CMF_DEFAULTONLY){
		dprintf(_T("\tCMF_DEFAULTONLY"));
		return MAKE_HRESULT(SEVERITY_SUCCESS,FACILITY_NULL,0);
	}

	if((uFlags&0x000F)!=CMF_NORMAL && !(uFlags&CMF_VERBSONLY) && !(uFlags&CMF_EXPLORE)/*c[r[ŉENbN*/){
		return MAKE_HRESULT(SEVERITY_SUCCESS,FACILITY_NULL,0);
	}

	// It@C̎o
	GetFileNames();

	//================
	// j[̕\
	//================
	// ŏ̃Zp[^ǉ
//	UtilInsertMenuItem(hMenu,NULL,indexMenu,NULL,0);
////	::InsertMenu(hMenu, indexMenu, MF_SEPARATOR | MF_BYPOSITION, 0, NULL);
//	indexMenu++;

	HMENU hTargetMenu=hMenu;
	if(ConfigManager.bUnderSubMenu){	//Tuj[ȉɕ荞ޏꍇ
		hTargetMenu=::CreatePopupMenu();
		m_MenuHandleList.push_back(hTargetMenu);
	}
	//ۂɃj[ǉ
	UINT TempIndexMenu=0;
	UINT CmdParamIndex=InsertContextMenu(hTargetMenu,ConfigManager.bUnderSubMenu?TempIndexMenu:/*ref*/indexMenu,idCmdFirst,ConfigManager.bUnderSubMenu);

	//؃R}ho^ĂȂꍇAj[͕\ĂȂƌȂB
	if(0!=CmdParamIndex){
		if(ConfigManager.bUnderSubMenu){	//Tuj[ȉɕ荞ޏꍇ
			TCHAR szBuffer[256];
			//uLhaForgevǉ
			::LoadString(g_hInstDLL,IDS_MENU_CAPTION_LHAFORGE,szBuffer,255);
			UtilInsertMenuItem(hMenu,szBuffer,indexMenu,hTargetMenu,idCmdFirst+CmdParamIndex);
			CmdParamIndex++;
			indexMenu++;
		}
		//------------------------
		// Ō̃Zp[^̒ǉ
		//------------------------
		UtilInsertMenuItem(hMenu,NULL,indexMenu,NULL,idCmdFirst+CmdParamIndex);
		CmdParamIndex++;
		indexMenu++;
	}

	//\bhꍇ́A{PꂽŌ̃j[ACẽj[ʎq܂codeoHRESULT \̂ŕԂ܂
	//From MSDN:the code member contains the menu identifier of the last menu item added plus one. 
	dprintf(_T("\tResultFromScode( idCmdFirst=%d,idCmdLast=%d : CmdParamIndex=%d)\n"),
		idCmdFirst,idCmdLast,CmdParamIndex);
	return MAKE_HRESULT(SEVERITY_SUCCESS, FACILITY_NULL,CmdParamIndex);
}

UINT CMenuExtension::InsertContextMenu(
	HMENU	hMenu,
	UINT	&indexMenu,
	UINT	idCmdFirst,
	BOOL	bInSubMenu)
{
	//================
	// j[̕\
	//================
	//R}hp[^̔z
	UINT CmdParamIndex=0;
	UINT nPopupMenuID=(UINT)m_CmdParamArray.size();	//|bvAbvj[ID:R}hIDɑă|bvAbv̍{IDU

	//ENbNj[ňk\KvƂ
	if(ConfigManager.ShellMenu.bCompress||ConfigManager.DragMenu.bCompress){
	//--------------
	// kj[
	//--------------

		// Topj[ǉ
		TCHAR szBuffer[256];
		if(ConfigManager.ShellMenu.bCompress){
			//ENbNj[̏ꍇ
			::LoadString(g_hInstDLL,IDS_MENU_CAPTION_COMPRESS,szBuffer,255);
		}
		else if(ConfigManager.DragMenu.bCompress){
			//EhbOj[̏ꍇ
			::LoadString(g_hInstDLL,IDS_MENU_CAPTION_COMPRESS_DRAG,szBuffer,255);
		}
		HMENU hCompressSubMenu=::CreatePopupMenu();
		m_MenuHandleList.push_back(hCompressSubMenu);

		dprintf(_T("MenuCaption=(%s),indexMenu=(%d)\n"),szBuffer,indexMenu);
		UtilInsertMenuItem(hMenu,szBuffer,indexMenu,hCompressSubMenu,idCmdFirst+nPopupMenuID);
		nPopupMenuID++;
		indexMenu++;

		// R}hp^ǉƂȂTuj[R}hǉ
		if(!ConfigManager.bExtraMenu){
			for(UINT i=0;i<m_nCompressMenuCount;i++){
				// R}hj[ǉ
				dprintf(_T("CmdParamindex=(%d),MenuCaption=(%s)\n"),CmdParamIndex,m_CmdParamArray[CmdParamIndex].MenuCaption);
				UtilInsertMenuItem(hCompressSubMenu,m_CmdParamArray[CmdParamIndex].MenuCaption,i,NULL,idCmdFirst+CmdParamIndex);
				CmdParamIndex++;
			}
		}
		else{
			int ExtraSubMenuIndex=0;
			EXTRA_MENU_ADD_MENU(hCompressSubMenu,CmdParamIndex,ExtraSubMenuIndex,idCmdFirst,m_MenuHandleList,LZH)
			EXTRA_MENU_ADD_MENU(hCompressSubMenu,CmdParamIndex,ExtraSubMenuIndex,idCmdFirst,m_MenuHandleList,ZIP)
			EXTRA_MENU_ADD_MENU(hCompressSubMenu,CmdParamIndex,ExtraSubMenuIndex,idCmdFirst,m_MenuHandleList,CAB)
			EXTRA_MENU_ADD_MENU(hCompressSubMenu,CmdParamIndex,ExtraSubMenuIndex,idCmdFirst,m_MenuHandleList,7Z)
			EXTRA_MENU_ADD_MENU(hCompressSubMenu,CmdParamIndex,ExtraSubMenuIndex,idCmdFirst,m_MenuHandleList,TAR)
			EXTRA_MENU_ADD_MENU(hCompressSubMenu,CmdParamIndex,ExtraSubMenuIndex,idCmdFirst,m_MenuHandleList,JACK)
			EXTRA_MENU_ADD_MENU(hCompressSubMenu,CmdParamIndex,ExtraSubMenuIndex,idCmdFirst,m_MenuHandleList,YZ1)
			EXTRA_MENU_ADD_MENU(hCompressSubMenu,CmdParamIndex,ExtraSubMenuIndex,idCmdFirst,m_MenuHandleList,HKI)
			EXTRA_MENU_ADD_MENU(hCompressSubMenu,CmdParamIndex,ExtraSubMenuIndex,idCmdFirst,m_MenuHandleList,BGA)
			EXTRA_MENU_ADD_MENU(hCompressSubMenu,CmdParamIndex,ExtraSubMenuIndex,idCmdFirst,m_MenuHandleList,AISH)
		}
	}

	//--------------
	// 𓀃j[
	//--------------
	if(ConfigManager.ShellMenu.bExtract){
		//ENbNj[̏ꍇ
		HMENU hExtractSubMenu=::CreatePopupMenu();
		m_MenuHandleList.push_back(hExtractSubMenu);

		//ENbNj[ŉ𓀂\KvƂ
		TCHAR szBuffer[256];
		//uLhaForgeŉ𓀁vǉ
		::LoadString(g_hInstDLL,IDS_MENU_CAPTION_EXTRACT,szBuffer,255);
		dprintf(_T("MenuCaption=(%s),indexMenu=(%d)\n"),szBuffer,indexMenu);
		UtilInsertMenuItem(hMenu,szBuffer,indexMenu,hExtractSubMenu,idCmdFirst+nPopupMenuID);
		nPopupMenuID++;
		indexMenu++;

		// R}hp^ǉƂȂTuj[R}hǉ
		for(UINT i=0;i<MAX_EXTRACT_MENU;i++){
			// R}hj[ǉ
			dprintf(_T("CmdParamindex=(%d),MenuCaption=(%s)\n"),CmdParamIndex,m_CmdParamArray[CmdParamIndex].MenuCaption);
			UtilInsertMenuItem(hExtractSubMenu,m_CmdParamArray[CmdParamIndex].MenuCaption,i,NULL,idCmdFirst+CmdParamIndex);
			CmdParamIndex++;
		}
	}
	else if(ConfigManager.DragMenu.bExtract){
		//EhbOj[̏ꍇ
		TCHAR szBuffer[256];
		::LoadString(g_hInstDLL,IDS_MENU_CAPTION_EXTRACT_DRAG,szBuffer,255);

		dprintf(_T("***CmdParamindex=(%d),Param=(%s)\n"),CmdParamIndex,m_CmdParamArray[CmdParamIndex].Param);
		UtilInsertMenuItem(hMenu,szBuffer,indexMenu,NULL,idCmdFirst+CmdParamIndex);
		CmdParamIndex++;
		indexMenu++;
	}

	//--------------
	// {j[
	//--------------
	const bool bSub=m_bXP&&!bInSubMenu&&!m_bRightDrag;
	HMENU hOperationMenu=hMenu;
	if(bSub){
		hOperationMenu=::CreatePopupMenu();
		m_MenuHandleList.push_back(hOperationMenu);
	}
	int subIndex=0;
	if(ConfigManager.ShellMenu.bList){
		//ENbNj[̏ꍇ̂
		dprintf(_T("CmdParamindex=(%d),Caption=(%s),indexMenu=(%d)\n"),CmdParamIndex,m_CmdParamArray[CmdParamIndex].MenuCaption,indexMenu);

		UtilInsertMenuItem(hOperationMenu,m_CmdParamArray[CmdParamIndex].MenuCaption,bSub?subIndex:indexMenu,NULL,idCmdFirst+CmdParamIndex);
		if(bSub)subIndex++;
			else indexMenu++;
		CmdParamIndex++;
	}

	//--------------
	// j[
	//--------------
	if(ConfigManager.ShellMenu.bTestArchive){
		//ENbNj[̏ꍇ̂
		dprintf(_T("CmdParamindex=(%d),Caption=(%s),indexMenu=(%d)\n"),CmdParamIndex,m_CmdParamArray[CmdParamIndex].MenuCaption,indexMenu);

		UtilInsertMenuItem(hOperationMenu,m_CmdParamArray[CmdParamIndex].MenuCaption,bSub?subIndex:indexMenu,NULL,idCmdFirst+CmdParamIndex);
		if(bSub)subIndex++;
			else indexMenu++;
		CmdParamIndex++;
	}
	//ꂽꍇ̂݃[U[j[Œǉ
	if(bSub){
		UINT subParamIndex=CmdParamIndex;
		if(ConfigManager.bXacRett)subParamIndex+=MAX_XACRETT_MENU;
		if(ConfigManager.bB2E)subParamIndex+=MAX_B2E_MENU;
		for(UINT i=0;i<m_nUserMenuCount;i++){
			// R}hj[ǉ
			dprintf(_T("CmdParamindex=(%d),MenuCaption=(%s)\n"),subParamIndex,m_CmdParamArray[subParamIndex].MenuCaption);
			UtilInsertMenuItem(hOperationMenu,m_CmdParamArray[subParamIndex].MenuCaption,subIndex,NULL,idCmdFirst+subParamIndex);
			subParamIndex++;
			subIndex++;
		}
	}
	//uLhaForgeővTuj[\
	if(bSub&&subIndex>0){
		TCHAR szBuffer[256];
		::LoadString(g_hInstDLL,IDS_MENU_CAPTION_OPERATION,szBuffer,255);
		UtilInsertMenuItem(hMenu,szBuffer,indexMenu,hOperationMenu,idCmdFirst+nPopupMenuID);
		indexMenu++;
		nPopupMenuID++;
	}


//-----------------
// XacRettj[
//-----------------
	if(ConfigManager.bXacRett){
		if(!m_bRightDrag){	//ENbNj[̏ꍇ
			HMENU hXacRettSubMenu=::CreatePopupMenu();
			m_MenuHandleList.push_back(hXacRettSubMenu);
			TCHAR szBuffer[256];
			//uLhaForge+XacRett.DLLvǉ
			::LoadString(g_hInstDLL,IDS_MENU_CAPTION_XACRETT,szBuffer,255);
			UtilInsertMenuItem(hMenu,szBuffer,indexMenu,hXacRettSubMenu,idCmdFirst+nPopupMenuID);
			nPopupMenuID++;
			indexMenu++;

			// R}hp^ǉƂȂTuj[R}hǉ
			for(UINT i=0;i<MAX_XACRETT_MENU;i++){
				// R}hj[ǉ
				dprintf(_T("CmdParamindex=(%d),MenuCaption=(%s)\n"),CmdParamIndex,m_CmdParamArray[CmdParamIndex].MenuCaption);
				UtilInsertMenuItem(hXacRettSubMenu,m_CmdParamArray[CmdParamIndex].MenuCaption,i,NULL,idCmdFirst+CmdParamIndex);
				CmdParamIndex++;
			}
		}
		else{
			//EhbOj[̏ꍇ
			TCHAR szBuffer[256];
			::LoadString(g_hInstDLL,IDS_MENU_CAPTION_XACRETT_DRAG,szBuffer,255);

			dprintf(_T("***CmdParamindex=(%d),Param=(%s)\n"),CmdParamIndex,m_CmdParamArray[CmdParamIndex].Param);
			UtilInsertMenuItem(hMenu,szBuffer,indexMenu,NULL,idCmdFirst+CmdParamIndex);
			CmdParamIndex++;
			indexMenu++;
		}
	}
//-----------------
// B2Ej[
//-----------------
	if(ConfigManager.bB2E){
		HMENU hB2ESubMenu=::CreatePopupMenu();
		m_MenuHandleList.push_back(hB2ESubMenu);
		TCHAR szBuffer[256];
		//uLhaForge+B2E32.DLLvǉ
		::LoadString(g_hInstDLL,IDS_MENU_CAPTION_B2E,szBuffer,255);
		UtilInsertMenuItem(hMenu,szBuffer,indexMenu,hB2ESubMenu,idCmdFirst+nPopupMenuID);
		nPopupMenuID++;
		indexMenu++;

		//k`j[ŕ\ȂTuj[ǉ
		//uB2Eł̌`ɈkvIȓe
		bool bMethodSelect=!ConfigManager.B2ECompressMenu.empty();
		if(bMethodSelect){
			HMENU hB2ECompressPopup=::CreatePopupMenu();
			m_MenuHandleList.push_back(hB2ECompressPopup);
			::LoadString(g_hInstDLL,IDS_MENU_CAPTION_B2E_COMPRESS_POPUP,szBuffer,255);
			UtilInsertMenuItem(hB2ESubMenu,szBuffer,0,hB2ECompressPopup,idCmdFirst+nPopupMenuID);
			nPopupMenuID++;

			//`Ƃ̃j[p
			for(UINT j=0;j<ConfigManager.B2ECompressMenu.size();j++){
				//`̃j[
				HMENU hTempMenu=::CreatePopupMenu();
				m_MenuHandleList.push_back(hTempMenu);
				UtilInsertMenuItem(hB2ECompressPopup,ConfigManager.B2ECompressMenu[j][0],j,hTempMenu,idCmdFirst+nPopupMenuID);
				nPopupMenuID++;
				for(UINT i=1;i<ConfigManager.B2ECompressMenu[j].size();i++){
					//\bh̃j[
					UtilInsertMenuItem(hTempMenu,ConfigManager.B2ECompressMenu[j][i],i-1,NULL,idCmdFirst+CmdParamIndex);
					CmdParamIndex++;
				}
			}
		}


		// R}hp^ǉƂȂTuj[R}hǉ
		const UINT nMax=m_bRightDrag?MAX_B2E_DRAG_MENU:MAX_B2E_MENU;
		for(UINT i=0;i<nMax;i++){
			// R}hj[ǉ
			dprintf(_T("CmdParamindex=(%d),MenuCaption=(%s)\n"),CmdParamIndex,m_CmdParamArray[CmdParamIndex].MenuCaption);
			if(bMethodSelect)	//B2EkIj[Έ炷
				UtilInsertMenuItem(hB2ESubMenu,m_CmdParamArray[CmdParamIndex].MenuCaption,i+1,NULL,idCmdFirst+CmdParamIndex);
			else
				UtilInsertMenuItem(hB2ESubMenu,m_CmdParamArray[CmdParamIndex].MenuCaption,i,NULL,idCmdFirst+CmdParamIndex);
			CmdParamIndex++;
		}
	}
//----------------------
// [U[`j[
//----------------------
	// R}hp^ǉƂȂTuj[R}hǉ
	if(!bSub){
		for(UINT i=0;i<m_nUserMenuCount;i++){
			// R}hj[ǉ
			dprintf(_T("CmdParamindex=(%d),MenuCaption=(%s)\n"),CmdParamIndex,m_CmdParamArray[CmdParamIndex].MenuCaption);
			UtilInsertMenuItem(hMenu,m_CmdParamArray[CmdParamIndex].MenuCaption,indexMenu,NULL,idCmdFirst+CmdParamIndex);
			CmdParamIndex++;
			indexMenu++;
		}
	}

	return nPopupMenuID;	//͒ǉj[+1Ɠ
}

// InvokeCommand
STDMETHODIMP CMenuExtension::InvokeCommand(
	LPCMINVOKECOMMANDINFO	lpcmi)
{
	dprintf(_T("CMenuExtension::InvokeCommand\n"));

	HRESULT hr = E_INVALIDARG;

	// HIWORD(lpcmi->lpVerb)0ł͂ȂƂ̂ݏ
	// LOWORD(lpcmi->lpVerb)̓NbNꂽj[ID
	// QueryContextMenu()ł (menu ID - idCmdFirst)
	if(!HIWORD(lpcmi->lpVerb)){
		UINT idCmd = LOWORD(lpcmi->lpVerb);

		// gj[̗L͈͂`FbN
		if(!m_CmdParamArray.empty() && idCmd >= 0 && idCmd < m_CmdParamArray.size()){
			// R}hs
			DoCommand(idCmd);
			hr = NOERROR;
		}
	}
	return hr;
}

// GetCommandString
STDMETHODIMP CMenuExtension::GetCommandString(
	UINT_PTR	idCmd,
	UINT	uType,
	UINT*	pwReserved,
	LPSTR	pszName,
	UINT cchMax)
{
	UNREFERENCED_PARAMETER(pwReserved);

	dprintf(_T("CMenuExtension::GetCommandString(ParamCount=%d : idCmd=%d)\n"),m_CmdParamArray.size(),idCmd);

	if(cchMax<2){
		//Z
		return E_INVALIDARG;
	}
	if(uType&GCS_HELPTEXT){
		*pszName = 0;
		*(pszName+1) = 0;

		if(m_CmdParamArray.empty())return NOERROR;	// ԕ

		// Xe[^X\
		if(idCmd >= 0 && idCmd < m_CmdParamArray.size()){
			TCHAR szCaption[256];
			::LoadString(g_hInstDLL,IDS_DEFAULT_STATUS_CAPTION,szCaption,255);
			if(uType&GCS_UNICODE){
				//UNICODE
				wcscpy_s((wchar_t*)pszName,cchMax,CT2W(szCaption));
			}else{
				//ANSI
				strcpy_s(pszName,cchMax,CT2A(szCaption));
			}
			dprintf(_T("\tMsg=%s)\n"),szCaption);
			return NOERROR;
		}
	}
	return E_INVALIDARG;
}


/////////////////////////////////////////////////////////////////////////////
//
// VFg@ReNXgj[̃Cvg
//
/////////////////////////////////////////////////////////////////////////////


/*-------------------------------------------------------------------------*/
//	GetFileNames		IĂt@C̎o
/*-------------------------------------------------------------------------*/

STDMETHODIMP CMenuExtension::GetFileNames()
{
	HRESULT thrResultH = S_FALSE;

	IEnumFORMATETC *theEnumFormatEtc = 0;
	thrResultH = m_DataObjP->EnumFormatEtc(DATADIR_GET, &theEnumFormatEtc);
	if(SUCCEEDED(thrResultH)){
		thrResultH = theEnumFormatEtc->Reset();
		if(SUCCEEDED(thrResultH)){
			FORMATETC theFormatEtc;
			ULONG theFetched = 0L;
			while(TRUE){
				thrResultH = theEnumFormatEtc->Next(1, &theFormatEtc, &theFetched);
				if(FAILED(thrResultH) || (theFetched <= 0)){
					dprintf(_T("GetFileNames():End of Data\n"));
					break;
				}
				theFormatEtc.cfFormat	= CF_HDROP;
				theFormatEtc.dwAspect	= DVASPECT_CONTENT;
				theFormatEtc.lindex		= -1;
				theFormatEtc.ptd		= NULL;
				theFormatEtc.tymed		= TYMED_HGLOBAL;
				STGMEDIUM theStgm;
				thrResultH = m_DataObjP->GetData(&theFormatEtc, &theStgm);
				if(SUCCEEDED(thrResultH)){
					if(theStgm.tymed == TYMED_HGLOBAL){
						UINT nFileCount = DragQueryFile((HDROP)theStgm.hGlobal, 0xFFFFFFFF, NULL, 0);
						if(nFileCount >= 1){
							m_SelFileArray.clear();
							for(UINT i=0; i<nFileCount;i++){
								TCHAR Buffer[_MAX_PATH+2]={0};
								DragQueryFile((HDROP)theStgm.hGlobal, i, Buffer, _MAX_PATH + 1);
								dprintf(_T("GetFileNames():%d/%d:%s\n"),i,nFileCount,Buffer);
								m_SelFileArray.push_back(Buffer);
							}
						}
					}
				}
			}
		}
	}
	if(theEnumFormatEtc)theEnumFormatEtc->Release();
	
	return thrResultH;
}

/*-------------------------------------------------------------------------*/
//	PrepareMenu		j[̏
/*-------------------------------------------------------------------------*/
void CMenuExtension::PrepareMenu()
{
	dprintf(_T("CMenuExtension::PrepareMenu\n"));

	//ݒǂݍ
	ConfigManager.LoadConfig(m_bRightDrag,m_bForceExtraMenu);

//========================
// \郁j[̑I
//========================

//R}hz쐬
#define ADD_CMDARRAY_SINGLE(CAPTION,PARAM)	\
{\
	/*ej[ACeݒ*/\
	TCHAR temp[256];\
	::LoadString(g_hInstDLL,CAPTION,temp,255);\
	MenuListItem mli;\
	mli.MenuCaption =temp;\
	/*R}hp^*/\
	mli.Param = PARAM;\
	m_CmdParamArray.push_back(mli);\
}

#define ADD_CMDARRAY(nMax,MenuArray)	\
{for(UINT iIndex=0;iIndex<nMax;iIndex++)\
	ADD_CMDARRAY_SINGLE(MenuArray[iIndex].Caption,MenuArray[iIndex].Param);\
}

#define ADD_CMDARRAY_USERMENU(ITEM)	/*j[LvV\[Xł͂Ȃo[W*/\
{\
	/*ej[ACeݒ*/\
	MenuListItem mli;\
	mli.MenuCaption =ITEM.Caption;\
	/*R}hp^*/\
	mli.Param = ITEM.Param;\
	m_CmdParamArray.push_back(mli);\
}

	if(ConfigManager.ShellMenu.bCompress||ConfigManager.DragMenu.bCompress){	//ENbNj[ňk\KvƂ
		if(ConfigManager.bExtraMenu){
			//Wj[
			EXTRA_MENU_ADD_CMD_TBL(m_CmdParamArray,LZH)
			EXTRA_MENU_ADD_CMD_TBL(m_CmdParamArray,ZIP)
			EXTRA_MENU_ADD_CMD_TBL(m_CmdParamArray,CAB)
			EXTRA_MENU_ADD_CMD_TBL(m_CmdParamArray,7Z)
			EXTRA_MENU_ADD_CMD_TBL(m_CmdParamArray,TAR)
			EXTRA_MENU_ADD_CMD_TBL(m_CmdParamArray,JACK)
			EXTRA_MENU_ADD_CMD_TBL(m_CmdParamArray,YZ1)
			EXTRA_MENU_ADD_CMD_TBL(m_CmdParamArray,HKI)
			EXTRA_MENU_ADD_CMD_TBL(m_CmdParamArray,BGA)
			EXTRA_MENU_ADD_CMD_TBL(m_CmdParamArray,AISH)
		}
		else if(!ConfigManager.bCustomCompress){
			ADD_CMDARRAY(MAX_COMPRESS_MENU,CompressMenu);
			m_nCompressMenuCount=MAX_COMPRESS_MENU;
		}
		else{
			//JX^}CYꂽj[g
			LPCTSTR lpChar=ConfigManager.szCustomCompress;

			m_nCompressMenuCount=0;
			dprintf(_T("CustomMenu Arrange Data=%s\n"),lpChar);
			for(;*lpChar!=_T('\0');lpChar++){
				int i;
				for(i=0;i<MAX_USER_MENU_TABLE;i++){
					if(UserMenuTable[i].Identifier==*lpChar){	//v
						break;
					}
				}
				if(i==MAX_USER_MENU_TABLE){	//v镨ȂA܂sȃj[w
					MessageBeep(MB_ICONEXCLAMATION);
					continue;
				}

				//j[ACeǉ

				ADD_CMDARRAY_SINGLE(UserMenuTable[i].lpMenuItem->Caption,UserMenuTable[i].lpMenuItem->Param);
				m_nCompressMenuCount++;
			}
		}
	}
	//--------------
	// 𓀃j[
	//--------------
	if(ConfigManager.DragMenu.bExtract){	//EhbOj[pӂꍇ
		//[ɉ]̂ݕ\̂ŁAMenuCaption(SubMenupȂ̂)gȂ
		MenuListItem mli;

		//R}hp^
		mli.Param = _T("/e");

		m_CmdParamArray.push_back(mli);
	}
	else if(ConfigManager.ShellMenu.bExtract){	//ENbN𓀃j[pӂꍇ
		ADD_CMDARRAY(MAX_EXTRACT_MENU,ExtractMenu);
	}
	//--------------
	// {j[
	//--------------
	//ENbNj[̂
	if(ConfigManager.ShellMenu.bList){	//ENbN{j[pӂꍇ
		ADD_CMDARRAY_SINGLE(IDS_MENU_CAPTION_LIST,_T("/l"));
	}
	//------------------
	// Ɍj[
	//------------------
	//ENbNj[̂
	if(ConfigManager.ShellMenu.bTestArchive){	//ENbNj[pӂꍇ
		ADD_CMDARRAY_SINGLE(IDS_MENU_CAPTION_TEST_ARCHIVE,_T("/t"));
	}
	//-----------------
	// XacRettj[
	//-----------------
	//LE
	if(ConfigManager.bXacRett){
		if(m_bRightDrag){	//EhbOj[pӂꍇ
			//[XacRettłɉ]̂ݕ\̂ŁAMenuCaption(SubMenupȂ̂)gȂ
			MenuListItem mli;

			//R}hp^
			mli.Param = _T("/xacrett /e");

			m_CmdParamArray.push_back(mli);
		}
		else{	//ENbNj[pӂꍇ
			ADD_CMDARRAY(MAX_XACRETT_MENU,XacRettMenu);
		}
	}
	//-----------------
	// B2Ej[
	//-----------------
	//LE
	if(ConfigManager.bB2E){
		if(!ConfigManager.B2ECompressMenu.empty()){//B2Ekj[pӂĂꍇ
			//B2Ekj[p
			for(std::vector<std::vector<CString> >::iterator ite=ConfigManager.B2ECompressMenu.begin();ite!=ConfigManager.B2ECompressMenu.end();++ite){
				for(UINT i=1;i<(*ite).size();i++){
					/*ej[ACeݒ*/
					MenuListItem mli;
					mli.MenuCaption=(*ite)[i];
					/*R}hp^*/
					mli.Param=_T("/b2e \"/c:");
					mli.Param+=(*ite)[0];
					mli.Param+=_T("\" \"/method:");
					mli.Param+=(*ite)[i];
					mli.Param+=_T("\" ");
					m_CmdParamArray.push_back(mli);
				}
			}
		}

		if(m_bRightDrag){	//EhbOj[pӂꍇ
			ADD_CMDARRAY(MAX_B2E_DRAG_MENU,B2EDragMenu);
		}
		else{	//ENbNj[pӂꍇ
			ADD_CMDARRAY(MAX_B2E_MENU,B2EMenu);
		}
	}

	//----------------------
	// [U[`j[
	//----------------------
	m_nUserMenuCount=0;
	if(ConfigManager.UserMenuArray.size()>0){
		for(UINT i=0;i<ConfigManager.UserMenuArray.size();i++){
			if(
				(ConfigManager.UserMenuArray[i].bShellMenu&&!m_bRightDrag)||
				(ConfigManager.UserMenuArray[i].bDragMenu&&m_bRightDrag)
			){
				ADD_CMDARRAY_USERMENU(ConfigManager.UserMenuArray[i]);
				m_nUserMenuCount++;
			}
		}
	}
}

/*-------------------------------------------------------------------------*/
//	DeleteFileData			It@Ce[uGA̔j
/*-------------------------------------------------------------------------*/
void CMenuExtension::DeleteFileData()
{
	m_SelFileArray.clear();
}

/*-------------------------------------------------------------------------*/
//	DeleteMenuData			j[f[^̔j
/*-------------------------------------------------------------------------*/
void CMenuExtension::DeleteMenuData()
{
	m_CmdParamArray.clear();
	//Tuj[p
	std::list<HMENU>::iterator ite;
	for(ite=m_MenuHandleList.begin();ite!=m_MenuHandleList.end();ite++){
		::DestroyMenu(*ite);
	}
	m_MenuHandleList.clear();
}

/*-------------------------------------------------------------------------*/
//	DoCommand		Igj[̃t@C`iJj
/*-------------------------------------------------------------------------*/
void CMenuExtension::DoCommand(UINT inIdx)
{
	// R}hIDƃR}hp^̗L̓`FbN

	dprintf(_T("DoCommand-> inIdx=%d : Param=%s\n"),inIdx,m_CmdParamArray[inIdx].Param);

	// tH_ɂ鈳kvO(LhaForge.exe)̃tpXgݗ
	TCHAR szExePath[_MAX_PATH+1];
	{
		::GetModuleFileName(g_hInstDLL, szExePath, _MAX_PATH);	//DLL̃pX擾
		//DLL̃pXLhaForgẽt@CgݗĂ
		PathRemoveFileSpec(szExePath);

		PathAppend(szExePath, _T("LhaForge.exe"));
		dprintf(_T("ExePath = %s\n"),szExePath);
	}
	CString CommandLine(szExePath);

	//R}hCp[^ݒ
	CommandLine+=_T(" ");
	CommandLine+=m_CmdParamArray[inIdx].Param;	//t@CIvV
	//Ɉk/
	if(m_bRightDrag){
		CommandLine+=_T(" /o:");
		CommandLine+=m_strTargetFolder;//ɕKvȏꍇ""ŊĂ
	}
	else{
		if(-1!=CommandLine.Find(OUTPUTDIR_DESKTOP)){
			//fXNgbvɉ
			TCHAR Buffer[_MAX_PATH+1]={0};
			SHGetSpecialFolderPath(NULL,Buffer,CSIDL_DESKTOPDIRECTORY,FALSE);
			PathQuoteSpaces(Buffer);
			CommandLine.Replace(OUTPUTDIR_DESKTOP,Buffer);
		}
		else if(-1!=CommandLine.Find(OUTPUTDIR_SAMEDIR)){
			//ꏊɉ
			CPath strPath(m_SelFileArray[0]);
			strPath.RemoveFileSpec();
			strPath.QuoteSpaces();
			CommandLine.Replace(OUTPUTDIR_SAMEDIR,strPath);
		}
		else if(-1!=CommandLine.Find(OUTPUTDIR_SPECIFIED)){
			//wꏊɉ
			TCHAR title[256];
			::LoadString(g_hInstDLL,IDS_INPUT_TARGET_FOLDER,title,255);
			CFolderDialog dlg(NULL,title,BIF_RETURNONLYFSDIRS|BIF_NEWDIALOGSTYLE);
			if(IDOK!=dlg.DoModal()){
				return;
			}
			CPath strPath(dlg.GetFolderPath());
			strPath.QuoteSpaces();
			CommandLine.Replace(OUTPUTDIR_SPECIFIED,strPath);
		}
	}

	//t@CԂɏ
	if(m_SelFileArray.size()>16){
		//t@ĈŃX|Xt@Cg(ɍ)
		TCHAR szTempPath[_MAX_PATH+1];
		{
			TCHAR szTempDir[_MAX_PATH+1];
			::GetTempPath(_MAX_PATH,szTempDir);
			if(!::GetTempFileName(szTempDir,_T("lf"),0,szTempPath)){
				MessageBeep(MB_ICONHAND);
				return;
			}
		}
		HANDLE hFile=::CreateFile(szTempPath,GENERIC_WRITE,0,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
		if(INVALID_HANDLE_VALUE==hFile){
			MessageBeep(MB_ICONHAND);
			return;
		}
		for(UINT file_count=0;file_count<m_SelFileArray.size();file_count++){
			UtilWriteLine(hFile,m_SelFileArray[file_count]);
		}
		::CloseHandle(hFile);
		//X|Xt@C̎w

#if defined(UNICODE)||defined(_UNICODE)
		//R[hy[Ww
		CommandLine+=_T(" /cp:UNICODE");
#endif

		CommandLine+=_T(" /$\"");
		CommandLine+=szTempPath;
		CommandLine+=_T("\"");
	}
	else{	//̂܂܃R}hCɓn
		for(UINT file_count=0;file_count<m_SelFileArray.size();file_count++){
			if(-1!=m_SelFileArray[file_count].Find(_T(' '))){
				//PathQuoteSpaces...
				CommandLine+=_T(" \"");
				CommandLine+=m_SelFileArray[file_count];
				CommandLine+=_T("\"");
			}else{
				CommandLine+=_T(" ");
				CommandLine+=m_SelFileArray[file_count];
			}
		}
	}

	// NvZX̕\EBhE̐ݒ
	STARTUPINFO theStartupInfo = {sizeof(STARTUPINFO)};
	theStartupInfo.dwFlags = STARTF_USESHOWWINDOW;
	theStartupInfo.wShowWindow = SW_SHOWDEFAULT;

	if(CommandLine.GetLength()>32*1024){	//p^32KB𒴂ƃG[Ƃ
		TCHAR msg[256];
		::LoadString(g_hInstDLL,IDS_ERROR_MSG_PARAM_OVERFLOW,msg,255);
		TCHAR title[256];
		::LoadString(g_hInstDLL,IDS_PROGRAM_NAME,title,255);
		MessageBox(NULL,msg,title,MB_OK|MB_ICONSTOP);
		return;
	}

	// vZXNiR}hsj
	PROCESS_INFORMATION	pi;
	BOOL	result = ::CreateProcess(NULL,CommandLine.GetBuffer(CommandLine.GetLength()+1),
						NULL,NULL,FALSE,CREATE_NEW_PROCESS_GROUP,
						NULL,NULL,&theStartupInfo,&pi);
	CommandLine.ReleaseBuffer();
	dprintf(_T("\tCreateProcess(%s)"),CommandLine);
	dprintf(_T(" result=%s\n"),result ? _T("OK") : _T("NG"));

	if(!result){
		CString Message=szExePath;
		Message+=_T("\n");
		{
			TCHAR szBuffer[256];
			::LoadString(g_hInstDLL,IDS_ERROR_MSG_FAILURE_EXECUTE,szBuffer,255);
			Message+=szBuffer;
		}

		//G[XgO擾
		{
			TCHAR szBuffer[1024];
			FormatMessage(
				FORMAT_MESSAGE_FROM_SYSTEM|FORMAT_MESSAGE_IGNORE_INSERTS,
				NULL, GetLastError(),
				MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // ftHg
				szBuffer, 1024, NULL);
			Message+=szBuffer;
		}
		{
			TCHAR title[256];
			::LoadString(g_hInstDLL,IDS_PROGRAM_NAME,title,255);
			MessageBox(NULL,Message,title,MB_OK|MB_ICONSTOP);
		}
	}

	//svɂȂvZXnh
	CloseHandle(pi.hProcess);
	CloseHandle(pi.hThread);
}


